#include <bits/stdc++.h>
#include "cycles.h"

void solve(std::vector<int64_t>& cycle) {
    if (cycle.size() == 1) { return; }
    int64_t x, y;
    while (x == y) {
        x = cycle[rand() % cycle.size()];
        y = cycle[rand() % cycle.size()];
    }
    const auto start = performSwap(x, y);
    std::vector<int64_t> left = {x}, right = {y};
    for (const auto it : cycle) if (it != x && it != y) {
        const auto next = performSwap(it, x);
        if (next > start) {
            left.push_back(it);
        } else {
            right.push_back(it);
        }
        performSwap(it, x);
    }
    solve(left);
    solve(right);
}

void sortPermutation(int n) {
    auto now = performSwap(0, 1);
    for (int64_t i = 1; i < n; i ++) {
        const auto next = performSwap(0, i);
        if (now < next) {
            performSwap(0, i);
        } else {
            now = next;
        }
    }
    assert(now == 1);
    std::vector<int64_t> all = {};
    for (int64_t i = 0; i < n; i ++) {
        all.push_back(i);
    }
    solve(all);
}
