#include <bits/stdc++.h>
#include <random>
#include <numeric>
#include <algorithm>
//#include "cycles.h"
using namespace std;

int performSwap(int x, int y);
mt19937 mtgen(1337);

void recSolve(vector<int> idxs)
{
    if (idxs.size() == 1)
        return;

    int v1 = 0;
    int v2 = 0;

    while(v1 == v2)
    {
        v1 = idxs[ mtgen() % idxs.size() ];
        v2 = idxs[ mtgen() % idxs.size() ];
    }

    int cur = performSwap(v1, v2);
    vector<int> A, B;
    A.push_back(v1);
    B.push_back(v2);
    for (auto idx : idxs)
    {
        if (idx == v1 || idx == v2)
            continue;

        int newVal = performSwap(idx, v1);
        if (newVal > cur)
            A.push_back(idx);
        else
            B.push_back(idx);

        performSwap(idx, v1);
    }

    recSolve(A);
    recSolve(B);
}

void sortPermutation(int n)
{
    std::vector<int> perm(n);
    std::iota(perm.begin(), perm.end(), 1);
    std::shuffle(perm.begin(), perm.end(), mtgen);

    int cycles = performSwap(0, 1);

    for (int t = 1; t < n && cycles > 1; t *= 2)
    {
        for (int i = 0; i + t < n && cycles > 1; i += 2 * t)
        {
            int newCycles = performSwap(i, i + t);
            if (newCycles < cycles) cycles = newCycles;
            else performSwap(i, i + t);
        }
    }

    vector<int> idxs(n);
    iota(idxs.begin(), idxs.end(), 0);
    recSolve(idxs);
}
