#include <bits/stdc++.h>
#include <random>
#include <numeric>
#include <algorithm>
//#include "cycles.h"
using namespace std;
typedef long long llong;

const int MAXN = 1022;

int performSwap(int x, int y);

llong flagKey = 1;
llong flags[MAXN];
int cntCycles(const vector<int>& perm)
{
    int ans = 0;
    flagKey++;
    for (int i = 0; i < perm.size(); i++)
    {
        if (flags[i] != flagKey)
        {
            ans++;
            int cur = i;
            while(flags[cur] != flagKey)
            {
                flags[cur] = flagKey;
                cur = perm[cur];
            }
            assert(cur == i);
        }
    }

    return ans;
}

mt19937 mtgen(1337);

struct DecisionNode
{
    pair<int, int> question;
    DecisionNode* moveUp = nullptr;
    DecisionNode* moveDown = nullptr;
};

vector<DecisionNode> mem(1000000);
int memCtr = 1;
map<vector<vector<int>>, DecisionNode*> choiceLookup;

DecisionNode* solveGreedy(vector<vector<int>> possibs)
{
    assert(!possibs.empty());

    int n = possibs[0].size();
    if (possibs.size() == 1)
    {
        assert(!mem.empty());
        pair<int, int> toswap = {-1, -1};
        for (int i = 0; i < n; i++)
        {
            for (int j = i; j < n; j++)
            {
                if (possibs[0][j] == i)
                {
                    if (i != j)
                    {
                        toswap = {i, j};
                    }

                    break;
                }
            }
            if (toswap.first >= 0)
                break;
        }
        if (toswap.first < 0)
        {
            return &mem[0];
        }
        else
        {
            swap(possibs[0][ toswap.first ], possibs[0][ toswap.second ]);
            DecisionNode* result = &mem[memCtr++];
            result->question = toswap;
            assert(toswap.first != toswap.second);
            result->moveUp = solveGreedy(possibs);
            return result;
        }
    }
    auto it = choiceLookup.find(possibs);
    if (it != choiceLookup.end())
        return it->second;

    pair<int, int> bestMove = {-1, -1};

    bool unknown = true;
    double minMaxLeftover = 0;
    int minMaxIdxs = 0;
    int maxIdxs = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = i + 1; j < n; j++)
        {
            map<int, vector<int>> answers;
            int idx = 0;
            for (vector<int>& permset : possibs)
            {
                swap(permset.at(i), permset.at(j));
                answers[ cntCycles(permset) ].push_back(idx++);
                swap(permset.at(i), permset.at(j));
            }

            double maxLeft = 0;
            maxIdxs = 0;
            for (auto& [ans, idxs]: answers)
            {
                maxIdxs = max(maxIdxs, (int)idxs.size());
                maxLeft = max(maxLeft, ((double)idxs.size()+1) * double(n - ans));
            }

            if (unknown || maxLeft < minMaxLeftover)
            {
                minMaxLeftover = maxLeft;
                minMaxIdxs = maxIdxs;
                unknown = false;
                bestMove = {i, j};
            }
        }
    }
    assert(!unknown);

    if (minMaxIdxs == possibs.size())
    {
        while(true)
        {
            bestMove = {mtgen() % n, mtgen() % n};
            if (bestMove.first != bestMove.second)
                break;
        }
    }

    int base = cntCycles(possibs.at(0));
    map<int, vector<int>> answers;
    int idx = 0;
    for (vector<int>& permset : possibs)
    {
        swap(permset.at(bestMove.first), permset.at(bestMove.second));
        answers[cntCycles(permset)].push_back(idx++);
        swap(permset.at( bestMove.first ), permset.at( bestMove.second ));
    }
    assert(answers.size() <= 2);

    DecisionNode* node = &mem[memCtr++];
    node->question = bestMove;
    assert(bestMove.first != bestMove.second);
    for (auto& [ans, idxs]: answers)
    {
        vector<vector<int>> new_state;
        for (auto idx : idxs)
        {
            new_state.push_back(possibs.at(idx));
            swap(new_state.back().at(bestMove.first), new_state.back().at(bestMove.second));
        }
        sort(new_state.begin(), new_state.end());

        DecisionNode* child = solveGreedy(new_state);
        assert(abs(ans - base) == 1);

        if (ans < base)
            node->moveDown = child;
        else
            node->moveUp = child;
    }

    choiceLookup[possibs] = node;

    return node;
}

int lastAns;
int mySwap(int x, int y)
{
    lastAns = performSwap(x, y);
    return lastAns;
}

vector<vector<int>> initials[12];

void getOpt(int sz)
{
    vector<int> perm(sz);
    iota(perm.begin(), perm.end(), 0);

    vector<vector<int>> initial;
    do
    {
        if (cntCycles(perm) == 1)
        {
            initial.push_back(perm);
        }
    }while(next_permutation(perm.begin(), perm.end()));
    initials[sz] = initial;

    solveGreedy(initial);
}

const int UPPER = 8;
const int LOWER = 4;

int totalOptTaken1 = 0;
int token1ctr = 0;
int totalOptTaken2 = 0;

void optSolve(vector<int> idxs)
{
    token1ctr++;

    int sz = idxs.size();
    DecisionNode* curNode = choiceLookup[initials[sz]];
    int base = lastAns;

    int starting = lastAns;

    int took = 0;

    assert(curNode != nullptr);
    while(curNode != nullptr)
    {
        if (curNode == (&mem[0]))
            break;

        pair<int, int> mv = curNode->question;
        int cur = mySwap(idxs[ mv.first ], idxs[ mv.second ]);
        totalOptTaken1++;
        took++;

        if (cur < base)
            curNode = curNode->moveDown;
        else
            curNode = curNode->moveUp;

        base = cur;
    }

    int ending = lastAns;

    if (ending - starting != sz - 1)
    {
        assert(ending - starting == sz - 1);
    }
}

void recSolve(vector<int> idxs)
{
    if (idxs.size() <= 1)
        return;
    if (idxs.size() >= LOWER && idxs.size() <= UPPER)
    {
        optSolve(idxs);
        return;
    }

    int v1 = 0;
    int v2 = 0;

    while(v1 == v2)
    {
        v1 = idxs[ mtgen() % idxs.size() ];
        v2 = idxs[ mtgen() % idxs.size() ];
    }

    int cur = mySwap(v1, v2);
    if (idxs.size() <= UPPER)
        totalOptTaken2++;
    vector<int> A, B;
    A.push_back(v1);
    B.push_back(v2);
    for (auto idx : idxs)
    {
        if (idx == v1 || idx == v2)
            continue;

        int newVal = mySwap(idx, v1);
        if (idxs.size() <= UPPER)
            totalOptTaken2++;
        if (newVal > cur)
            A.push_back(idx);
        else
            B.push_back(idx);

        mySwap(idx, v1);
    }

    recSolve(A);
    recSolve(B);
}

void sortPermutation(int n)
{
    for (int i = LOWER; i <= UPPER; i++)
    {
        getOpt(i);
    }
    assert(memCtr < mem.size());

    int initial = performSwap(0, 1);
    for (int i = 1; i < n; i++)
    {
        int newCycles = performSwap(i - 1, i);

        if (newCycles > initial)
        {
            newCycles = performSwap(i - 1, i);
        }

        initial = newCycles;
    }

    vector<int> idxs(n);
    iota(idxs.begin(), idxs.end(), 0);
    recSolve(idxs);

    //printf("Things in opt took a total of %d | %d\n", totalOptTaken1, totalOptTaken2);

    //cout << "Averages " << double(totalOptTaken1) / double(token1ctr) << endl;
}

